# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from aruco_mapping/ArucoMarker.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class ArucoMarker(genpy.Message):
  _md5sum = "e73493d4620efa2f38fe39e7896d4192"
  _type = "aruco_mapping/ArucoMarker"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header
bool marker_visibile
int32 num_of_visible_markers
geometry_msgs/Pose global_camera_pose
int32[] marker_ids
geometry_msgs/Pose[] global_marker_poses


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['header','marker_visibile','num_of_visible_markers','global_camera_pose','marker_ids','global_marker_poses']
  _slot_types = ['std_msgs/Header','bool','int32','geometry_msgs/Pose','int32[]','geometry_msgs/Pose[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,marker_visibile,num_of_visible_markers,global_camera_pose,marker_ids,global_marker_poses

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ArucoMarker, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.marker_visibile is None:
        self.marker_visibile = False
      if self.num_of_visible_markers is None:
        self.num_of_visible_markers = 0
      if self.global_camera_pose is None:
        self.global_camera_pose = geometry_msgs.msg.Pose()
      if self.marker_ids is None:
        self.marker_ids = []
      if self.global_marker_poses is None:
        self.global_marker_poses = []
    else:
      self.header = std_msgs.msg.Header()
      self.marker_visibile = False
      self.num_of_visible_markers = 0
      self.global_camera_pose = geometry_msgs.msg.Pose()
      self.marker_ids = []
      self.global_marker_poses = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_Bi7d.pack(_x.marker_visibile, _x.num_of_visible_markers, _x.global_camera_pose.position.x, _x.global_camera_pose.position.y, _x.global_camera_pose.position.z, _x.global_camera_pose.orientation.x, _x.global_camera_pose.orientation.y, _x.global_camera_pose.orientation.z, _x.global_camera_pose.orientation.w))
      length = len(self.marker_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.marker_ids))
      length = len(self.global_marker_poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.global_marker_poses:
        _v1 = val1.position
        _x = _v1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v2 = val1.orientation
        _x = _v2
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.global_camera_pose is None:
        self.global_camera_pose = geometry_msgs.msg.Pose()
      if self.global_marker_poses is None:
        self.global_marker_poses = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 61
      (_x.marker_visibile, _x.num_of_visible_markers, _x.global_camera_pose.position.x, _x.global_camera_pose.position.y, _x.global_camera_pose.position.z, _x.global_camera_pose.orientation.x, _x.global_camera_pose.orientation.y, _x.global_camera_pose.orientation.z, _x.global_camera_pose.orientation.w,) = _struct_Bi7d.unpack(str[start:end])
      self.marker_visibile = bool(self.marker_visibile)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.marker_ids = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.global_marker_poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose()
        _v3 = val1.position
        _x = _v3
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v4 = val1.orientation
        _x = _v4
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.global_marker_poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_Bi7d.pack(_x.marker_visibile, _x.num_of_visible_markers, _x.global_camera_pose.position.x, _x.global_camera_pose.position.y, _x.global_camera_pose.position.z, _x.global_camera_pose.orientation.x, _x.global_camera_pose.orientation.y, _x.global_camera_pose.orientation.z, _x.global_camera_pose.orientation.w))
      length = len(self.marker_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.marker_ids.tostring())
      length = len(self.global_marker_poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.global_marker_poses:
        _v5 = val1.position
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = val1.orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.global_camera_pose is None:
        self.global_camera_pose = geometry_msgs.msg.Pose()
      if self.global_marker_poses is None:
        self.global_marker_poses = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 61
      (_x.marker_visibile, _x.num_of_visible_markers, _x.global_camera_pose.position.x, _x.global_camera_pose.position.y, _x.global_camera_pose.position.z, _x.global_camera_pose.orientation.x, _x.global_camera_pose.orientation.y, _x.global_camera_pose.orientation.z, _x.global_camera_pose.orientation.w,) = _struct_Bi7d.unpack(str[start:end])
      self.marker_visibile = bool(self.marker_visibile)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.marker_ids = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.global_marker_poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Pose()
        _v7 = val1.position
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v8 = val1.orientation
        _x = _v8
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.global_marker_poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_Bi7d = struct.Struct("<Bi7d")
_struct_3d = struct.Struct("<3d")
